
import { useState,  useEffect } from 'react';

import Request, {YWRequestConfig} from '@ywfe/request';
// @ts-ignore
import * as querystring from 'querystring';
// @ts-ignore
import { ParsedUrlQueryInput } from 'querystring';
// @ts-ignore
import * as R from 'ramda';
import {configs} from './config';


  const projectId = "PROAUTH";
  let env;
  if(typeof window === 'undefined'){
    env = (process.env.REACT_APP_ENV === 'prod' ? 'prod': process.env.REACT_APP_ENV) || 'prod';
  } else {
    env = window.localStorage.getItem('env') || (process.env.REACT_APP_ENV === 'prod' ? 'prod': process.env.REACT_APP_ENV) || 'prod';
  }
  
  const basePath = configs[projectId] ? configs[projectId][env].API_BASE_URL + `${env === 'mock' ? '/' + 88 : ''}` : '';
  const loginPath = configs['AUTH'] ? configs['AUTH'][env].APPLICATION_URL : '';
  

  

// @ts-ignore




export interface DesktopCloudUnlockModuleInput {
  
    
    /** 模块id */
    moduleId?: string;
  
}

export interface DesktopCloudUnlockModuleData {
  
}


const reduceParams = (data: R.Dictionary<DesktopCloudUnlockModuleInput>) => {
  if(data instanceof FormData){
    return data;
  }
  const result = R.filter(item => !R.isNil(item) && !R.isEmpty(item))(data) || {};
  return result as unknown as DesktopCloudUnlockModuleInput;
}


// 20855 解绑用户模块

  export const usePostDesktopCloudUnlockModule = () => {
    let isMount = true;
    const [isDesktopCloudUnlockModuleLoading, setIsDesktopCloudUnlockModuleLoading] = useState(false);
    const [dataDesktopCloudUnlockModule, setDataDesktopCloudUnlockModule] = useState<DesktopCloudUnlockModuleData>({} as DesktopCloudUnlockModuleData);
    const postDesktopCloudUnlockModuleData = async(inputs: DesktopCloudUnlockModuleInput, config?: YWRequestConfig): Promise<DesktopCloudUnlockModuleData> => {
      
        const params = reduceParams(inputs as unknown as R.Dictionary<DesktopCloudUnlockModuleInput>) || {};
      
      if(isMount){
        setIsDesktopCloudUnlockModuleLoading(true);
      }
      
      try{
        
          
          
          const res: any = await Request.post<DesktopCloudUnlockModuleData>(`${basePath}/desktop/cloud/unlock/module`, params, {
            loginHost: loginPath,
            ...config
          });
          
          
          if(isMount){
            setDataDesktopCloudUnlockModule(res || {});
            setIsDesktopCloudUnlockModuleLoading(false);
          }
          return res;
      } catch(error){
        console.log(error);
        if(isMount){
          setIsDesktopCloudUnlockModuleLoading(false);
        }
        return false as unknown as DesktopCloudUnlockModuleData;
      }
      
    }

    useEffect(() => {
      return () => {
        isMount = false;
      };
    }, []);
  
    return {
      isDesktopCloudUnlockModuleLoading,
      dataDesktopCloudUnlockModule,
      postDesktopCloudUnlockModuleData,
    }
  }

